
_InitTimeBase:

;TimeBase.mpas,59 :: 		begin
;TimeBase.mpas,60 :: 		TimerValue := 0;
	CLRF        TimeBase_TimerValue+0 
	CLRF        TimeBase_TimerValue+1 
;TimeBase.mpas,61 :: 		TimerValueSeconds := 0;
	CLRF        TimeBase_TimerValueSeconds+0 
	CLRF        TimeBase_TimerValueSeconds+1 
;TimeBase.mpas,62 :: 		Temp := 0;
	CLRF        TimeBase_Temp+0 
	CLRF        TimeBase_Temp+1 
;TimeBase.mpas,63 :: 		end;
L_end_InitTimeBase:
	RETURN      0
; end of _InitTimeBase

_UpdateTimeBase:

;TimeBase.mpas,66 :: 		begin
;TimeBase.mpas,67 :: 		inc(TimerValue); // with wrap around
	INFSNZ      TimeBase_TimerValue+0, 1 
	INCF        TimeBase_TimerValue+1, 1 
;TimeBase.mpas,68 :: 		inc(Temp);
	INFSNZ      TimeBase_Temp+0, 1 
	INCF        TimeBase_Temp+1, 1 
;TimeBase.mpas,69 :: 		if Temp = 1000 then // one second elapsed
	MOVF        TimeBase_Temp+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__UpdateTimeBase21
	MOVLW       232
	XORWF       TimeBase_Temp+0, 0 
L__UpdateTimeBase21:
	BTFSS       STATUS+0, 2 
	GOTO        L__UpdateTimeBase3
;TimeBase.mpas,71 :: 		Temp := 0;
	CLRF        TimeBase_Temp+0 
	CLRF        TimeBase_Temp+1 
;TimeBase.mpas,72 :: 		inc(TimerValueSeconds);
	INFSNZ      TimeBase_TimerValueSeconds+0, 1 
	INCF        TimeBase_TimerValueSeconds+1, 1 
;TimeBase.mpas,73 :: 		end;
L__UpdateTimeBase3:
;TimeBase.mpas,74 :: 		end;
L_end_UpdateTimeBase:
	RETURN      0
; end of _UpdateTimeBase

_TimeNow:

;TimeBase.mpas,77 :: 		begin
;TimeBase.mpas,78 :: 		TimebaseTimerInterruptBit := 0;
	BCF         TimebaseTimerInterruptBit+0, BitPos(TimebaseTimerInterruptBit+0) 
;TimeBase.mpas,79 :: 		Result := TimerValue;
	MOVF        TimeBase_TimerValue+0, 0 
	MOVWF       R2 
	MOVF        TimeBase_TimerValue+1, 0 
	MOVWF       R3 
;TimeBase.mpas,80 :: 		TimebaseTimerInterruptBit := 1;
	BSF         TimebaseTimerInterruptBit+0, BitPos(TimebaseTimerInterruptBit+0) 
;TimeBase.mpas,81 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
	MOVF        R3, 0 
	MOVWF       R1 
L_end_TimeNow:
	RETURN      0
; end of _TimeNow

_TimeNowSeconds:

;TimeBase.mpas,84 :: 		begin
;TimeBase.mpas,85 :: 		TimebaseTimerInterruptBit := 0;
	BCF         TimebaseTimerInterruptBit+0, BitPos(TimebaseTimerInterruptBit+0) 
;TimeBase.mpas,86 :: 		Result := TimerValueSeconds;
	MOVF        TimeBase_TimerValueSeconds+0, 0 
	MOVWF       R2 
	MOVF        TimeBase_TimerValueSeconds+1, 0 
	MOVWF       R3 
;TimeBase.mpas,87 :: 		TimebaseTimerInterruptBit := 1;
	BSF         TimebaseTimerInterruptBit+0, BitPos(TimebaseTimerInterruptBit+0) 
;TimeBase.mpas,88 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
	MOVF        R3, 0 
	MOVWF       R1 
L_end_TimeNowSeconds:
	RETURN      0
; end of _TimeNowSeconds

_TimeElapsed:

;TimeBase.mpas,92 :: 		begin
;TimeBase.mpas,93 :: 		Tmp := TimeNow;
	CALL        _TimeNow+0, 0
	MOVF        R0, 0 
	MOVWF       TimeElapsed_Tmp+0 
	MOVF        R1, 0 
	MOVWF       TimeElapsed_Tmp+1 
;TimeBase.mpas,94 :: 		if Tmp >= Mark
	MOVF        FARG_TimeElapsed_Mark+1, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__TimeElapsed25
	MOVF        FARG_TimeElapsed_Mark+0, 0 
	SUBWF       R0, 0 
L__TimeElapsed25:
	BTFSS       STATUS+0, 0 
	GOTO        L__TimeElapsed9
;TimeBase.mpas,95 :: 		then Result := Tmp - Mark
	MOVF        FARG_TimeElapsed_Mark+0, 0 
	SUBWF       TimeElapsed_Tmp+0, 0 
	MOVWF       TimeElapsed_local_result+0 
	MOVF        FARG_TimeElapsed_Mark+1, 0 
	SUBWFB      TimeElapsed_Tmp+1, 0 
	MOVWF       TimeElapsed_local_result+1 
	GOTO        L__TimeElapsed10
;TimeBase.mpas,96 :: 		else Result := DWord(Tmp + MaxWord + 1) - Mark;
L__TimeElapsed9:
	MOVLW       255
	ADDWF       TimeElapsed_Tmp+0, 0 
	MOVWF       R0 
	MOVLW       255
	ADDWFC      TimeElapsed_Tmp+1, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R2, 1 
	MOVLW       0
	MOVWF       R3 
	MOVLW       0
	ADDWFC      R3, 1 
	MOVLW       1
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	ADDWFC      R2, 1 
	ADDWFC      R3, 1 
	MOVF        FARG_TimeElapsed_Mark+0, 0 
	SUBWF       R0, 0 
	MOVWF       TimeElapsed_local_result+0 
	MOVF        FARG_TimeElapsed_Mark+1, 0 
	SUBWFB      R1, 0 
	MOVWF       TimeElapsed_local_result+1 
L__TimeElapsed10:
;TimeBase.mpas,97 :: 		end;
	MOVF        TimeElapsed_local_result+0, 0 
	MOVWF       R0 
	MOVF        TimeElapsed_local_result+1, 0 
	MOVWF       R1 
L_end_TimeElapsed:
	RETURN      0
; end of _TimeElapsed

_TimeElapsedSeconds:

;TimeBase.mpas,101 :: 		begin
;TimeBase.mpas,102 :: 		Tmp := TimeNowSeconds;
	CALL        _TimeNowSeconds+0, 0
	MOVF        R0, 0 
	MOVWF       TimeElapsedSeconds_Tmp+0 
	MOVF        R1, 0 
	MOVWF       TimeElapsedSeconds_Tmp+1 
;TimeBase.mpas,103 :: 		if Tmp >= Mark
	MOVF        FARG_TimeElapsedSeconds_Mark+1, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__TimeElapsedSeconds27
	MOVF        FARG_TimeElapsedSeconds_Mark+0, 0 
	SUBWF       R0, 0 
L__TimeElapsedSeconds27:
	BTFSS       STATUS+0, 0 
	GOTO        L__TimeElapsedSeconds13
;TimeBase.mpas,104 :: 		then Result := Tmp - Mark
	MOVF        FARG_TimeElapsedSeconds_Mark+0, 0 
	SUBWF       TimeElapsedSeconds_Tmp+0, 0 
	MOVWF       TimeElapsedSeconds_local_result+0 
	MOVF        FARG_TimeElapsedSeconds_Mark+1, 0 
	SUBWFB      TimeElapsedSeconds_Tmp+1, 0 
	MOVWF       TimeElapsedSeconds_local_result+1 
	GOTO        L__TimeElapsedSeconds14
;TimeBase.mpas,105 :: 		else Result := DWord(Tmp + MaxWord + 1) - Mark;
L__TimeElapsedSeconds13:
	MOVLW       255
	ADDWF       TimeElapsedSeconds_Tmp+0, 0 
	MOVWF       R0 
	MOVLW       255
	ADDWFC      TimeElapsedSeconds_Tmp+1, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R2, 1 
	MOVLW       0
	MOVWF       R3 
	MOVLW       0
	ADDWFC      R3, 1 
	MOVLW       1
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	ADDWFC      R2, 1 
	ADDWFC      R3, 1 
	MOVF        FARG_TimeElapsedSeconds_Mark+0, 0 
	SUBWF       R0, 0 
	MOVWF       TimeElapsedSeconds_local_result+0 
	MOVF        FARG_TimeElapsedSeconds_Mark+1, 0 
	SUBWFB      R1, 0 
	MOVWF       TimeElapsedSeconds_local_result+1 
L__TimeElapsedSeconds14:
;TimeBase.mpas,106 :: 		end;
	MOVF        TimeElapsedSeconds_local_result+0, 0 
	MOVWF       R0 
	MOVF        TimeElapsedSeconds_local_result+1, 0 
	MOVWF       R1 
L_end_TimeElapsedSeconds:
	RETURN      0
; end of _TimeElapsedSeconds

_TimeDiff:

;TimeBase.mpas,109 :: 		begin
;TimeBase.mpas,110 :: 		if NewTime >= OldTime
	MOVF        FARG_TimeDiff_OldTime+1, 0 
	SUBWF       FARG_TimeDiff_NewTime+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__TimeDiff29
	MOVF        FARG_TimeDiff_OldTime+0, 0 
	SUBWF       FARG_TimeDiff_NewTime+0, 0 
L__TimeDiff29:
	BTFSS       STATUS+0, 0 
	GOTO        L__TimeDiff17
;TimeBase.mpas,111 :: 		then Result := NewTime - OldTime
	MOVF        FARG_TimeDiff_OldTime+0, 0 
	SUBWF       FARG_TimeDiff_NewTime+0, 0 
	MOVWF       R4 
	MOVF        FARG_TimeDiff_OldTime+1, 0 
	SUBWFB      FARG_TimeDiff_NewTime+1, 0 
	MOVWF       R5 
	GOTO        L__TimeDiff18
;TimeBase.mpas,112 :: 		else Result := DWord(NewTime + MaxWord + 1) - OldTime;
L__TimeDiff17:
	MOVLW       255
	ADDWF       FARG_TimeDiff_NewTime+0, 0 
	MOVWF       R0 
	MOVLW       255
	ADDWFC      FARG_TimeDiff_NewTime+1, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R2, 1 
	MOVLW       0
	MOVWF       R3 
	MOVLW       0
	ADDWFC      R3, 1 
	MOVLW       1
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	ADDWFC      R2, 1 
	ADDWFC      R3, 1 
	MOVF        FARG_TimeDiff_OldTime+0, 0 
	SUBWF       R0, 0 
	MOVWF       R4 
	MOVF        FARG_TimeDiff_OldTime+1, 0 
	SUBWFB      R1, 0 
	MOVWF       R5 
L__TimeDiff18:
;TimeBase.mpas,113 :: 		end;
	MOVF        R4, 0 
	MOVWF       R0 
	MOVF        R5, 0 
	MOVWF       R1 
L_end_TimeDiff:
	RETURN      0
; end of _TimeDiff
