
_Cos_Init:

;Cos.mpas,81 :: 		begin
;Cos.mpas,82 :: 		Cos_Running := false;
	CLRF        Cos_Cos_Running+0 
;Cos.mpas,85 :: 		memset(^byte(@Cos_TaskQueue[0]),      0, sizeOf(Cos_TaskQueue));
	MOVLW       Cos_Cos_TaskQueue+0
	MOVWF       FARG_memset_p+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVLW       126
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;Cos.mpas,86 :: 		memset(^byte(@Cos_TaskQueue_ISR[0]),  0, sizeOf(Cos_TaskQueue_ISR));
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	MOVWF       FARG_memset_p+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVLW       126
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;Cos.mpas,87 :: 		memset(^byte(@Cos_TimedTaskQueue[0]), 0, sizeOf(Cos_TimedTaskQueue));
	MOVLW       Cos_Cos_TimedTaskQueue+0
	MOVWF       FARG_memset_p+0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVLW       210
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;Cos.mpas,88 :: 		end;
L_end_Cos_Init:
	RETURN      0
; end of _Cos_Init

_Cos_Start:

;Cos.mpas,96 :: 		begin
;Cos.mpas,98 :: 		Cos_Running := true;
	MOVLW       255
	MOVWF       Cos_Cos_Running+0 
;Cos.mpas,99 :: 		CosTimerInterruptbit := 1;      // enable CosTimer interrupt
	BSF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,101 :: 		while Cos_Running do
L__Cos_Start3:
	MOVF        Cos_Cos_Running+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start4
;Cos.mpas,111 :: 		CosTimerInterruptBit := 0; // disable interrupts (prevent changing of the Queue while it is copied)
	BCF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,114 :: 		memcpy(^byte(@TaskQueue_ISR_Copy[0]), ^byte(@Cos_TaskQueue_ISR[0]), sizeOf(TaskQueue_ISR_Copy));
	MOVLW       Cos_Start_TaskQueue_ISR_Copy+0
	MOVWF       FARG_memcpy_p1+0 
	MOVLW       hi_addr(Cos_Start_TaskQueue_ISR_Copy+0)
	MOVWF       FARG_memcpy_p1+1 
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	MOVWF       FARG_memcpy_p2+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	MOVWF       FARG_memcpy_p2+1 
	MOVLW       126
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;Cos.mpas,117 :: 		memset(^byte(@Cos_TaskQueue_ISR[0]), 0, sizeOf(Cos_TaskQueue_ISR));
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	MOVWF       FARG_memset_p+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVLW       126
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;Cos.mpas,119 :: 		CosTimerInterruptBit := 1; // enable interrupts again
	BSF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,122 :: 		I    := 0;
	CLRF        Cos_Start_I+0 
;Cos.mpas,123 :: 		Func := TaskQueue_ISR_Copy[I].TaskPtr;
	MOVLW       Cos_Start_TaskQueue_ISR_Copy+0
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Start_TaskQueue_ISR_Copy+0)
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,124 :: 		while Func <> 0 do
L__Cos_Start8:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_Start_Func+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start84
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start84
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start84
	MOVF        Cos_Start_Func+0, 0 
	XORLW       0
L__Cos_Start84:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start9
;Cos.mpas,127 :: 		TmpPar := TaskQueue_ISR_Copy[I].Param;
	MOVLW       Cos_Start_TaskQueue_ISR_Copy+0
	MOVWF       FLOC__Cos_Start+0 
	MOVLW       hi_addr(Cos_Start_TaskQueue_ISR_Copy+0)
	MOVWF       FLOC__Cos_Start+1 
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        FLOC__Cos_Start+0, 0 
	ADDWF       R0, 1 
	MOVF        FLOC__Cos_Start+1, 0 
	ADDWFC      R1, 1 
	MOVLW       4
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
;Cos.mpas,130 :: 		Func^(TmpPar);
	MOVF        Cos_Start_Func+2, 0 
	MOVWF       FSR1 
	MOVF        Cos_Start_Func+3, 0 
	MOVWF       FSR1H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Cos_Start_Func+0, 0 
	MOVWF       R0 
	MOVF        Cos_Start_Func+1, 0 
	MOVWF       R1 
	CALL        _____DoIFC+0, 0
;Cos.mpas,133 :: 		inc(I);
	INCF        Cos_Start_I+0, 1 
;Cos.mpas,134 :: 		Func := TaskQueue_ISR_Copy[I].TaskPtr;
	MOVLW       Cos_Start_TaskQueue_ISR_Copy+0
	MOVWF       FLOC__Cos_Start+0 
	MOVLW       hi_addr(Cos_Start_TaskQueue_ISR_Copy+0)
	MOVWF       FLOC__Cos_Start+1 
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	ADDWF       FLOC__Cos_Start+0, 0 
	MOVWF       FSR0 
	MOVF        R1, 0 
	ADDWFC      FLOC__Cos_Start+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,135 :: 		end;
	GOTO        L__Cos_Start8
L__Cos_Start9:
;Cos.mpas,143 :: 		I := 0;
	CLRF        Cos_Start_I+0 
;Cos.mpas,144 :: 		while I < (COS_MAX_NR_TASKS - 1) do
L__Cos_Start13:
	MOVLW       19
	SUBWF       Cos_Start_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Cos_Start14
;Cos.mpas,146 :: 		Executed := false;
	CLRF        Cos_Start_Executed+0 
;Cos.mpas,148 :: 		CosTimerInterruptbit := 0;  // disable Cos timer interrupt
	BCF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,149 :: 		Func          := Cos_TimedTaskQueue[I].TaskPtr;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
	MOVF        POSTINC0+0, 0 
	MOVWF       R6 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        R4, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        R5, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        R6, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        R7, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,150 :: 		TmpCounter    := Cos_TimedTaskQueue[I].DownCounter;
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       6
	ADDWF       R2, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_TmpCounter+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_TmpCounter+1 
;Cos.mpas,151 :: 		TmpRepetitive := Cos_TimedTaskQueue[I].RepetitionTime;
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       8
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_TmpRepetitive+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_TmpRepetitive+1 
;Cos.mpas,152 :: 		CosTimerInterruptbit := 1;  // enable Cos timer interrupt
	BSF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,154 :: 		if Func <> 0 then
	MOVLW       0
	MOVWF       R0 
	XORWF       R7, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start85
	MOVF        R0, 0 
	XORWF       R6, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start85
	MOVF        R0, 0 
	XORWF       R5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start85
	MOVF        R4, 0 
	XORLW       0
L__Cos_Start85:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start18
;Cos.mpas,157 :: 		if TmpCounter = 0 then // wait time is over
	MOVLW       0
	XORWF       Cos_Start_TmpCounter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start86
	MOVLW       0
	XORWF       Cos_Start_TmpCounter+0, 0 
L__Cos_Start86:
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start21
;Cos.mpas,159 :: 		TmpPar := Cos_TimedTaskQueue[I].Param; // get parameter
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       4
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
;Cos.mpas,161 :: 		Func^(TmpPar); // execute task
	MOVF        Cos_Start_Func+2, 0 
	MOVWF       FSR1 
	MOVF        Cos_Start_Func+3, 0 
	MOVWF       FSR1H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Cos_Start_Func+0, 0 
	MOVWF       R0 
	MOVF        Cos_Start_Func+1, 0 
	MOVWF       R1 
	CALL        _____DoIFC+0, 0
;Cos.mpas,163 :: 		CosTimerInterruptbit := 0;  // disable Cos timer interrupt
	BCF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,165 :: 		if TmpRepetitive = 0 then // non repeated task
	MOVLW       0
	XORWF       Cos_Start_TmpRepetitive+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start87
	MOVLW       0
	XORWF       Cos_Start_TmpRepetitive+0, 0 
L__Cos_Start87:
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start24
;Cos.mpas,168 :: 		J := I;
	MOVF        Cos_Start_I+0, 0 
	MOVWF       Cos_Start_J+0 
;Cos.mpas,169 :: 		Func := Cos_TimedTaskQueue[J].TaskPtr;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,170 :: 		while Func <> 0 do
L__Cos_Start27:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_Start_Func+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start88
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start88
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start88
	MOVF        Cos_Start_Func+0, 0 
	XORLW       0
L__Cos_Start88:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start28
;Cos.mpas,172 :: 		memcpy(^byte(@Cos_TimedTaskQueue[J]), ^byte(@Cos_TimedTaskQueue[J+1]), Sizeof(Cos_TimedTaskData));
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_J+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        Cos_Start_J+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVLW       10
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;Cos.mpas,173 :: 		inc(J);
	INCF        Cos_Start_J+0, 1 
;Cos.mpas,174 :: 		Func := Cos_TimedTaskQueue[J].TaskPtr;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_J+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,175 :: 		end;
	GOTO        L__Cos_Start27
L__Cos_Start28:
;Cos.mpas,176 :: 		end
	GOTO        L__Cos_Start25
;Cos.mpas,177 :: 		else Cos_TimedTaskQueue[I].DownCounter := TmpRepetitive; // repetitive task, resubmit it
L__Cos_Start24:
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       6
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        Cos_Start_TmpRepetitive+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Cos_Start_TmpRepetitive+1, 0 
	MOVWF       POSTINC1+0 
L__Cos_Start25:
;Cos.mpas,179 :: 		Executed := true;
	MOVLW       255
	MOVWF       Cos_Start_Executed+0 
;Cos.mpas,180 :: 		CosTimerInterruptbit := 1;  // enable Cos timer interrupt
	BSF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,181 :: 		end;
L__Cos_Start21:
;Cos.mpas,183 :: 		end;
L__Cos_Start18:
;Cos.mpas,185 :: 		if not Executed then inc(I);
	COMF        Cos_Start_Executed+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start32
	INCF        Cos_Start_I+0, 1 
L__Cos_Start32:
;Cos.mpas,186 :: 		end;
	GOTO        L__Cos_Start13
L__Cos_Start14:
;Cos.mpas,194 :: 		Func := Cos_TaskQueue[0].TaskPtr;
	MOVF        Cos_Cos_TaskQueue+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        Cos_Cos_TaskQueue+1, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        Cos_Cos_TaskQueue+2, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        Cos_Cos_TaskQueue+3, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,195 :: 		if Func <> 0 then
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_Cos_TaskQueue+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start89
	MOVF        R0, 0 
	XORWF       Cos_Cos_TaskQueue+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start89
	MOVF        R0, 0 
	XORWF       Cos_Cos_TaskQueue+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start89
	MOVF        Cos_Cos_TaskQueue+0, 0 
	XORLW       0
L__Cos_Start89:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start35
;Cos.mpas,200 :: 		Func^(TmpPar);
	MOVF        Cos_Start_Func+2, 0 
	MOVWF       FSR1 
	MOVF        Cos_Start_Func+3, 0 
	MOVWF       FSR1H 
	MOVF        Cos_Cos_TaskQueue+4, 0 
	MOVWF       POSTINC1+0 
	MOVF        Cos_Cos_TaskQueue+5, 0 
	MOVWF       POSTINC1+0 
	MOVF        Cos_Start_Func+0, 0 
	MOVWF       R0 
	MOVF        Cos_Start_Func+1, 0 
	MOVWF       R1 
	CALL        _____DoIFC+0, 0
;Cos.mpas,203 :: 		I := 0;
	CLRF        Cos_Start_I+0 
;Cos.mpas,204 :: 		Func := Cos_TaskQueue[I].TaskPtr;
	CLRF        R0 
	CLRF        R1 
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,205 :: 		while Func <> 0 do
L__Cos_Start38:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_Start_Func+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start90
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start90
	MOVF        R0, 0 
	XORWF       Cos_Start_Func+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_Start90
	MOVF        Cos_Start_Func+0, 0 
	XORLW       0
L__Cos_Start90:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_Start39
;Cos.mpas,207 :: 		memcpy(^byte(@Cos_TaskQueue[I]), ^byte(@Cos_TaskQueue[I + 1]), SizeOf(Cos_TaskData));
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        Cos_Start_I+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       6
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVLW       6
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;Cos.mpas,208 :: 		inc(I);
	INCF        Cos_Start_I+0, 1 
;Cos.mpas,209 :: 		Func := Cos_TaskQueue[I].TaskPtr;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_Start_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_Start_Func+3 
;Cos.mpas,210 :: 		end;
	GOTO        L__Cos_Start38
L__Cos_Start39:
;Cos.mpas,211 :: 		end;
L__Cos_Start35:
;Cos.mpas,213 :: 		end;
	GOTO        L__Cos_Start3
L__Cos_Start4:
;Cos.mpas,215 :: 		end;
L_end_Cos_Start:
	RETURN      0
; end of _Cos_Start

_Cos_Stop:

;Cos.mpas,218 :: 		begin
;Cos.mpas,219 :: 		CosTimerInterruptbit := 0;      // disable CosTimer interrupt
	BCF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,220 :: 		Cos_Running := false;
	CLRF        Cos_Cos_Running+0 
;Cos.mpas,221 :: 		end;
L_end_Cos_Stop:
	RETURN      0
; end of _Cos_Stop

_Cos_SubmitTask:

;Cos.mpas,226 :: 		begin
;Cos.mpas,228 :: 		I := 0;
	CLRF        Cos_SubmitTask_I+0 
;Cos.mpas,229 :: 		Tmp := Cos_TaskQueue[I].TaskPtr;
	CLRF        R0 
	CLRF        R1 
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+3 
;Cos.mpas,230 :: 		while (Tmp <> 0) do
L__Cos_SubmitTask45:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_SubmitTask_Tmp+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask93
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_Tmp+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask93
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_Tmp+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask93
	MOVF        Cos_SubmitTask_Tmp+0, 0 
	XORLW       0
L__Cos_SubmitTask93:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask46
;Cos.mpas,232 :: 		inc(I); // find first free place
	INCF        Cos_SubmitTask_I+0, 1 
;Cos.mpas,233 :: 		Tmp := Cos_TaskQueue[I].TaskPtr;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Tmp+3 
;Cos.mpas,234 :: 		end;
	GOTO        L__Cos_SubmitTask45
L__Cos_SubmitTask46:
;Cos.mpas,235 :: 		if I < COS_MAX_NR_TASKS then                   // only insert when Queue is not full
	MOVLW       20
	SUBWF       Cos_SubmitTask_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Cos_SubmitTask50
;Cos.mpas,237 :: 		Cos_TaskQueue[I].TaskPtr := Task_;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Task_+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Task_+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Task_+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Task_+3, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,238 :: 		Cos_TaskQueue[I].Param   := Parameter;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       4
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Parameter+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Parameter+1, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,239 :: 		end;
L__Cos_SubmitTask50:
;Cos.mpas,240 :: 		end;
L_end_Cos_SubmitTask:
	RETURN      0
; end of _Cos_SubmitTask

_Cos_SubmitTask_Timed:

;Cos.mpas,245 :: 		begin
;Cos.mpas,246 :: 		CosTimerInterruptbit := 0;  // disable CosTimer interrupt
	BCF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,249 :: 		I := 0;
	CLRF        Cos_SubmitTask_Timed_I+0 
;Cos.mpas,250 :: 		Tmp := Cos_TimedTaskQueue[I].TaskPtr;         // first entry in Queue
	CLRF        R0 
	CLRF        R1 
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+3 
;Cos.mpas,251 :: 		while (Tmp <> 0) do
L__Cos_SubmitTask_Timed54:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_SubmitTask_Timed_Tmp+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_Timed95
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_Timed_Tmp+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_Timed95
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_Timed_Tmp+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_Timed95
	MOVF        Cos_SubmitTask_Timed_Tmp+0, 0 
	XORLW       0
L__Cos_SubmitTask_Timed95:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_Timed55
;Cos.mpas,253 :: 		inc(I); // find first free place
	INCF        Cos_SubmitTask_Timed_I+0, 1 
;Cos.mpas,254 :: 		Tmp := Cos_TimedTaskQueue[I].TaskPtr;       // next entry in Queue
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_Timed_Tmp+3 
;Cos.mpas,255 :: 		end;
	GOTO        L__Cos_SubmitTask_Timed54
L__Cos_SubmitTask_Timed55:
;Cos.mpas,257 :: 		if I < COS_MAX_NR_TASKS then                   // only insert when Queue is not full
	MOVLW       20
	SUBWF       Cos_SubmitTask_Timed_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Cos_SubmitTask_Timed59
;Cos.mpas,259 :: 		Cos_TimedTaskQueue[I].TaskPtr     := Task_;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Timed_Task_+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Task_+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Task_+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Task_+3, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,260 :: 		Cos_TimedTaskQueue[I].Param       := Parameter;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       4
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Timed_Parameter+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Parameter+1, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,261 :: 		Cos_TimedTaskQueue[I].DownCounter := Tme;
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       6
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Timed_Tme+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Tme+1, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,262 :: 		if Repetitive
	MOVF        FARG_Cos_SubmitTask_Timed_Repetitive+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_Timed62
;Cos.mpas,263 :: 		then Cos_TimedTaskQueue[I].RepetitionTime := Tme // store repetitiontime
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       8
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_Timed_Tme+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_Timed_Tme+1, 0 
	MOVWF       POSTINC1+0 
	GOTO        L__Cos_SubmitTask_Timed63
;Cos.mpas,264 :: 		else Cos_TimedTaskQueue[I].RepetitionTime := 0;
L__Cos_SubmitTask_Timed62:
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_Timed_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       8
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
L__Cos_SubmitTask_Timed63:
;Cos.mpas,265 :: 		end;
L__Cos_SubmitTask_Timed59:
;Cos.mpas,267 :: 		CosTimerInterruptbit := 1;  // enable CosTimer interrupt
	BSF         CosTimerInterruptBit+0, BitPos(CosTimerInterruptBit+0) 
;Cos.mpas,268 :: 		end;
L_end_Cos_SubmitTask_Timed:
	RETURN      0
; end of _Cos_SubmitTask_Timed

_Cos_SubmitTask_From_ISR:

;Cos.mpas,273 :: 		begin
;Cos.mpas,275 :: 		I := 0;
	CLRF        Cos_SubmitTask_From_ISR_I+0 
;Cos.mpas,276 :: 		Tmp := Cos_TaskQueue_ISR[I].TaskPtr;          // first entry in Queue
	CLRF        R0 
	CLRF        R1 
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+3 
;Cos.mpas,277 :: 		while (Tmp <> 0) do
L__Cos_SubmitTask_From_ISR66:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_SubmitTask_From_ISR_Tmp+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_From_ISR97
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_From_ISR_Tmp+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_From_ISR97
	MOVF        R0, 0 
	XORWF       Cos_SubmitTask_From_ISR_Tmp+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_From_ISR97
	MOVF        Cos_SubmitTask_From_ISR_Tmp+0, 0 
	XORLW       0
L__Cos_SubmitTask_From_ISR97:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_SubmitTask_From_ISR67
;Cos.mpas,279 :: 		inc(I); // find first free place
	INCF        Cos_SubmitTask_From_ISR_I+0, 1 
;Cos.mpas,280 :: 		Tmp := Cos_TaskQueue_ISR[I].TaskPtr;        // next entry in Queue
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_From_ISR_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_SubmitTask_From_ISR_Tmp+3 
;Cos.mpas,281 :: 		end;
	GOTO        L__Cos_SubmitTask_From_ISR66
L__Cos_SubmitTask_From_ISR67:
;Cos.mpas,282 :: 		if I < COS_MAX_NR_TASKS then                   // only insert when Queue is not full
	MOVLW       20
	SUBWF       Cos_SubmitTask_From_ISR_I+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Cos_SubmitTask_From_ISR71
;Cos.mpas,284 :: 		Cos_TaskQueue_ISR[I].TaskPtr := Task_;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_From_ISR_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Task_+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Task_+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Task_+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Task_+3, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,285 :: 		Cos_TaskQueue_ISR[I].Param   := Parameter;
	MOVLW       6
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_SubmitTask_From_ISR_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TaskQueue_ISR+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TaskQueue_ISR+0)
	ADDWFC      R1, 1 
	MOVLW       4
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Parameter+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Cos_SubmitTask_From_ISR_Parameter+1, 0 
	MOVWF       POSTINC1+0 
;Cos.mpas,286 :: 		end;
L__Cos_SubmitTask_From_ISR71:
;Cos.mpas,287 :: 		end;
L_end_Cos_SubmitTask_From_ISR:
	RETURN      0
; end of _Cos_SubmitTask_From_ISR

_Cos_TimerInterrupt:

;Cos.mpas,292 :: 		begin
;Cos.mpas,295 :: 		I := 0;
	CLRF        Cos_TimerInterrupt_I+0 
;Cos.mpas,296 :: 		Tmp := Cos_TimedTaskQueue[I].TaskPtr;   // first entry in timed Queue
	CLRF        R0 
	CLRF        R1 
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+3 
;Cos.mpas,297 :: 		while (Tmp <> 0) do
L__Cos_TimerInterrupt75:
	MOVLW       0
	MOVWF       R0 
	XORWF       Cos_TimerInterrupt_Tmp+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_TimerInterrupt99
	MOVF        R0, 0 
	XORWF       Cos_TimerInterrupt_Tmp+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_TimerInterrupt99
	MOVF        R0, 0 
	XORWF       Cos_TimerInterrupt_Tmp+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_TimerInterrupt99
	MOVF        Cos_TimerInterrupt_Tmp+0, 0 
	XORLW       0
L__Cos_TimerInterrupt99:
	BTFSC       STATUS+0, 2 
	GOTO        L__Cos_TimerInterrupt76
;Cos.mpas,299 :: 		if Cos_TimedTaskQueue[I].DownCounter > 0 then dec(Cos_TimedTaskQueue[I].DownCounter);
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_TimerInterrupt_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       6
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R2, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Cos_TimerInterrupt100
	MOVF        R1, 0 
	SUBLW       0
L__Cos_TimerInterrupt100:
	BTFSC       STATUS+0, 0 
	GOTO        L__Cos_TimerInterrupt80
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_TimerInterrupt_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 1 
	MOVLW       6
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0
	MOVFF       R3, FSR0H
	MOVLW       1
	SUBWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	SUBWFB      POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1
	MOVFF       R3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
L__Cos_TimerInterrupt80:
;Cos.mpas,300 :: 		inc(I);
	INCF        Cos_TimerInterrupt_I+0, 1 
;Cos.mpas,301 :: 		Tmp := Cos_TimedTaskQueue[I].TaskPtr; // next entry in the timed Queue
	MOVLW       10
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Cos_TimerInterrupt_I+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Cos_Cos_TimedTaskQueue+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(Cos_Cos_TimedTaskQueue+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       Cos_TimerInterrupt_Tmp+3 
;Cos.mpas,302 :: 		end;
	GOTO        L__Cos_TimerInterrupt75
L__Cos_TimerInterrupt76:
;Cos.mpas,304 :: 		end;
L_end_Cos_TimerInterrupt:
	RETURN      0
; end of _Cos_TimerInterrupt
